import sys
import serial
import time
#PORT = "/dev/ttyACM0"
#ser = serial.Serial(PORT, 19200)

from sendingInformation import *
from checkingChangesAndMakingLists import *

def running():
    
    #To print data to arduino without receiving data: (Test)
    prevDigits = 0

    
        
    while True:
        
        #we have to close and open the serial to get new data
        #otherwise ser.inWaiting keeps sending values

        ser.close()
        ser.open()
        time.sleep(1)
        

        """
        a = ser.read()
        print a
        b = ser.read()
        print b
        c = ser.read()
        print c
        d = ser.read()
        print d


        """

        print "NEW RUN"
        data_left = ser.inWaiting() 
        #print data_left
        tdata = ser.read()           # Wait forever for anything
        
        print "tdata"
        time.sleep(1)               # Sleep (or inWaiting() doesn't give the correct value)
        #print "b"
        data_left = ser.inWaiting()  # Get the number of characters ready to be read
        
        #print "left", data_left
        
        tdata += ser.read(data_left) # Do the read and combine it with the first character
        #print "hi"
        #print tdata
        

        
        #newDigits =  int(tdata.rstrip())
        
        
        a = tdata
        #print "a is" + a
        b = a.rstrip()
        #print "b is " + b
        #print "converted to digit: ", b.isdigit()
        try:
            c = float(b)
        except:
            print "float didn't work"
                
        #print "c is", c
            
        try:
            newDigits = int(c)
            print newDigits
        except:
            print "int didn't work" 
                                    
           
        changed = checkingChange(prevDigits, newDigits) #applying function 2
            
        print "changed: ", changed

        if changed: #if True: 
                
            print prevDigits, newDigits 
                
            newLists = makingLists(changed, prevDigits, newDigits) #tuple of 3
            #newLists[0] = updated prevDigits
            #newLists[1] = time
            #newLists[2] = chemicals

            #print newLists

   
            #selectedData = beforeSendingData([1], [1], currentData, "position", 0, 0, ["m", "l"])
            #returns prevDataSet and numbers to sent for motors or lights
            #dataSent(selectedData = beforeSendingData(t, chem, prevDataSet, colToCompare, rowNumber1, rowNumber2, motorsOrLights)
            
            
            #sent = ser.write("12\r\n")
            #MIGHT CHANGE!!!!!!!!!!!

            #selectedData has the 6 numbers for motors and lights!!! (comes from beforeSendingData)...
            
            selectedData1 = beforeSendingData(newLists[1], newLists[2], currentData, "position", 0, 3, ["l"]) #####CHANGED FROM 3 TO 0
            sent = dataSent(selectedData1)
            prevDigits = str(newLists[0]) #put it back to strings 
                            
            print prevDigits, newDigits 
            print "END OF SECTION"

    return sent

#----------------------------------------------------------------------------------------------------

